#include "movieCollection.h"

Node* createNode(MovieRecord newData) // helper function
{
    Node* pMem = malloc(sizeof(Node)); // request allocating space for Node

    if (pMem != NULL)
    {
        // let's intialize the Node
        pMem->pLink = NULL;
        // pMem->data = newData; // struct assignment
        pMem->data.year = newData.year;
        strcpy(pMem->data.title, newData.title);
    }

    return pMem;
}

int insertAtFront(Node** pList, MovieRecord newData)
{
    Node* pMem = malloc(sizeof(Node)); // request allocating space for Node
    int success = 0; // failed to allocate space on the heap

    if (pMem != NULL)
    {
        // we allocated space for a Node successfully
        success = 1;

        // let's intialize the Node
        pMem->pLink = NULL;
       // pMem->data = newData; // struct assignment
        pMem->data.year = newData.year;
        strcpy(pMem->data.title, newData.title);

        // we init the new Node
        // empty list?
        if ((*pList) == NULL)
        {
            // it is empty list
            *pList = pMem;
        }
        else
        {
            // it is not empty
            pMem->pLink = *pList;
            *pList = pMem;
        }
    }

    return success;
}

// dictionary ordering (A - Z)
int insertInOrder(Node** pList, MovieRecord newData)
{
    Node* pMem = createNode(newData), *pCur = *pList, *pPrev = NULL;
    int success = 0;

    if (pMem != NULL)
    {
        // allocated space successfully for a Node
        success = 1;

        if (*pList == NULL)
        {
            // the list is empty
            *pList = pMem;
        }
        else // list is not empty
        {
            while (pCur != NULL && (strcmp(newData.title, pCur->data.title) > 0))
            {
                // we'll complete on Fri, 1/26
            }
        }
    }
}

// precondition: list must not be empty
MovieRecord deleteFront(Node** pList)
{
    Node* pTemp = *pList;
    MovieRecord rec = pTemp->data;

    // update the head ptr (pHead)
    *pList = pTemp->pLink;
    free(pTemp);

    return rec;
}

void printList(Node* pList)
{
    printf("--> ");

    while (pList != NULL)
    {
        // there's another Node - print the data
        printf("%s, %d--> ", pList->data.title, pList->data.year);
        pList = pList->pLink;
    }

    putchar('\n');
}